//
//  AppController.m
//  MyCalculator

#import "AppController.h"
#import "MyWindow.h"

@implementation AppController
- (void)awakeFromNib
{
	isClear = 0;
	prevOperation = 0;
	totalValue = 0;

	[myWindow setAppController:self];
	NSLog(@"sdf");
}

- (void)processCalcul:(int)val
{
	if([[txtValue stringValue] length] == 0)
		return;
	
	if(prevOperation == BTN_PLUS)
		totalValue += [txtValue intValue];
	else if(prevOperation == BTN_MINUS)
		totalValue -= [txtValue intValue];
	else if(prevOperation == BTN_MULTIPLE)
		totalValue *= [txtValue intValue];
	else if(prevOperation == BTN_DIVISION)
		totalValue /= [txtValue intValue];
	
	if([[txtHistory stringValue] length] < 1)
		totalValue = [txtValue floatValue];
	
	char operation;
	NSString *strTemp;
	
	if(val == BTN_PLUS)
		operation = '+';
	else if(val == BTN_MINUS)
		operation = '-';
	else if(val == BTN_MULTIPLE)
		operation = '*';
	else if(val == BTN_DIVISION)
		operation = '/';
	else
		operation = '=';
	
	if(val == BTN_RESULT)
		strTemp = [[NSString alloc] initWithFormat:@"= %d\n", totalValue];
	else
		strTemp = [[NSString alloc] initWithFormat:@"%c", operation];
	
	isClear = 1;
	prevOperation = val;
	
	[txtOperation setStringValue:[NSString stringWithFormat:@"%c", operation]];
	[txtHistory setStringValue:[NSString stringWithFormat:@"%@ %@ %@", 
		[txtHistory stringValue],
		[txtValue stringValue],
		strTemp]];
	
	[txtValue setFloatValue:totalValue];
	[strTemp release];
}

- (void)processInput:(int)val
{
	NSLog(@">> %d", val);
	
	NSString *strTemp;
	
	if(val >= 0 && val <= 9) 
	{
		if(isClear == 1)
		{
			[txtValue setStringValue:@""];
			isClear = 0;
		}	
		strTemp = [NSString stringWithFormat:@"%@%d", [txtValue stringValue], val];
		[txtValue setStringValue:strTemp];
	}	
	else if(val == BTN_CLEAR)
	{
		isClear = 0;
		prevOperation = 0;
		
		[txtValue setStringValue:@""];
		[txtHistory setStringValue:@""];
		[txtOperation setStringValue:@""];
	}
	else if(val >= BTN_PLUS && val <= BTN_RESULT)
	{
		if([[txtValue stringValue] length] > 0)
			[self processCalcul:val];
	}
}

- (IBAction) processCommand:(id)sender
{
	int val = [[sender selectedCell] tag];
	
	[self processInput:val];
}
@end
